﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Reflection;

namespace Builder
{
    public partial class Component : Button // UserControl
    {
        private Type type;
        public Type getType() { return type;  }

        public Component (Type t)
        {
            InitializeComponent();
            type = t;
            Text = type.Name;

            // using System.Reflection;
            MethodInfo m = t.GetMethod ("getBasicColor", BindingFlags.Public | BindingFlags.Static);
            if (m != null)
            {
                Object value = m.Invoke (null, null);
                this.BackColor = (Color) value;
            }
        }

        public object CreateInstance ()
        {
            Object obj = Activator.CreateInstance (type);
            return obj;
        }

        private void Component_MouseDown(object sender, MouseEventArgs e)
        {
            DoDragDrop (this, DragDropEffects.Copy);
        }
    }
}
